module Day3.Part2 (
  splitIntoGroups,
  badgeOfGroup,
  sumOfBadgePriorities,
)
where

import Day3.Shared
import Data.List.Split
import qualified Data.Set as Set
import Control.Lens

type Group = (Contents, Contents, Contents)
type Badge = Char

splitIntoGroups :: String -> [Group]
splitIntoGroups =  map asTriple . chunksOf 3 . lines

asTriple :: [Contents] -> Group
asTriple ls = (head ls, ls !! 1, ls !! 2)

badgeOfGroup :: Group -> Badge
badgeOfGroup g = inAll
  where
    (a, b, c) = over each Set.fromList g
    inAll = head . Set.elems $ a `Set.intersection` b `Set.intersection` c

sumOfBadgePriorities :: String -> Int
sumOfBadgePriorities input = maybeSum $ map itemPriority badges
  where
    badges = map badgeOfGroup $ splitIntoGroups input
    