module Day6 (
  findEnd,
  findStart,
  day6
) where

import qualified Data.Sequence as S
import Data.Sequence (Seq (..), (|>))

findStart :: String -> Maybe Int
findStart = findUniqueSubstring 14

findEnd :: String -> Maybe Int
findEnd = findUniqueSubstring 4

findUniqueSubstring :: Int -> String -> Maybe Int
findUniqueSubstring size input
 | length input < size = Nothing -- imposible to find a substring because input is too small
 | otherwise = find 0 S.empty $ S.fromList input
  where
    find :: Int -> Seq Char -> Seq Char -> Maybe Int
    find _ _ Empty = Nothing
    find off window (r :<| rs)
      = case S.elemIndexL r window of -- is new element in window?
        Nothing -> if S.length window == size -1            -- Element not found, but is our window large nough?
                      then Just nextOff                     -- Large enough, we got a winner!
                      else find nextOff enlargedWindow rs   -- Not large enough, push new element to the end of the window
        Just i -> find nextOff  (removeConflict (i + 1)) rs -- continue after clearing window
      where
        nextOff = off + 1
        enlargedWindow = window |> r
        removeConflict i = S.drop i enlargedWindow

day6 :: IO ()
day6 = do
   input <- readFile "ressources/day06-input"
   putStrLn "Day6"
   let offset = findEnd input
   putStrLn ("Found end marker at " ++ show offset)
   let startOffset = findStart input
   putStrLn ("Found start marker at " ++ show startOffset)
